## fwknop 2.6.0

=== debian/changelog ===
fwknop (2.6.0-4) unstable; urgency=medium

  * QA upload.
  * debian/rules: Disable verbose dh mode.
  * Add --with-gpg=/usr/bin/gpg to configure call. Closes: #833465.
    This should probably not be required at all as we are using libgpgme,
    but at least it will not FTBFS and should behave as before.

 -- Santiago Vila <sanvila@debian.org>  Fri, 05 Aug 2016 00:29:16 +0200

fwknop (2.6.0-3) unstable; urgency=medium

  * QA upload.
  * Package is orphaned (Bug #831273). Set maintainer to "Debian QA Group".
  * Fix debian/rules for "dpkg-buildpackage -A" to work. Closes: #806027.
  * Fix spelling error in libfko2-dev short description.

 -- Santiago Vila <sanvila@debian.org>  Fri, 15 Jul 2016 15:05:36 +0100

fwknop (2.6.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Use "find -perm /x" instead of "find -perm +x". Closes: #808926

 -- Andreas Metzler <ametzler@debian.org>  Fri, 25 Dec 2015 14:24:41 +0100

fwknop (2.6.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "hardcodes /usr/lib/perl5":
    Use $Config{vendorarch} in debian/rules.
    (Closes: #752472)

 -- gregor herrmann <gregoa@debian.org>  Sat, 02 Aug 2014 17:58:22 +0200

fwknop (2.6.0-2) unstable; urgency=low

  * Moved installation of usr.sbin/fwknopd from d.rules to 
    fwknop-apparmor-profile.install file. (Closes: #735766)
  * Added copyright stanza for android files in d.copyright
   (Closes: #735668).

 -- Franck Joncourt <franck@debian.org>  Sat, 18 Jan 2014 21:42:00 +0100

fwknop (2.6.0-1) unstable; urgency=low

  * Imported Upstream version 2.6.0
  
  * New fwknop-apparmor-profile package to provide the fwknop-server apparmor
    profile.
    - New entry in d.control to create the brand new binary package.
    - Added BD on dh-apparmor.
    - Updated d.rules to used dh_apparmor to manage developer scripts.
    - Added fwknop-apparmor-profile.dirs file to create apparmor directory at
      install.
    - Added fwknop-apparmor-profile as suggested package for the fwknop server
      in d.control.
  * Bump up debian policy from 3.9.4 to 3.9.5:
    - Removed dependencies on dpkg (>= 1.15.4) | install-info

 -- Franck Joncourt <franck@debian.org>  Mon, 13 Jan 2014 22:10:17 +0100

=== debian/control ===
Source: fwknop
Section: admin
Priority: extra
Build-Depends: debhelper (>= 9), automake, libtool, libgpgme11-dev,
 texinfo, libpcap0.8-dev, po-debconf, libgdbm-dev, iptables,
 dpkg-dev (>= 1.16.1~), chrpath, python-all-dev, dh-apparmor
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/collab-maint/fwknop.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/fwknop.git;a=summary
Homepage: http://www.cipherdyne.com/fwknop/
X-Python-Version: >= 2.7

Package: libfko2-dev
Architecture: linux-any
Section: libdevel
Provides: libfko-dev
Conflicts: libfko-dev
Suggests: libfko-doc
Depends: ${shlibs:Depends}, libfko2 (= ${binary:Version}), ${misc:Depends}
Description: FireWall KNock OPerator - development library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the development library and its headers.

Package: libfko2-dbg
Architecture: linux-any
Section: debug
Depends: libfko2 (= ${binary:Version}), ${misc:Depends}
Description: FireWall KNock OPerator - debugging symbols
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the debugging symbols for the library as well as for
 the fwknop server and client programs (C version only).

Package: libfko2
Section: libs
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FireWall KNock OPerator - shared library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the runtime library for fwknop (written inC).

Package: libfko-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: FireWall KNock OPerator - documentation
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the library documentation.

Package: libfko-perl
Section: perl
Architecture: linux-any
Depends: ${perl:Depends},  libfko2 (= ${binary:Version}), ${shlibs:Depends},
 ${misc:Depends}
Description: FireWall KNock OPerator - Perl module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the FKO module as a Perl interface.

Package: fwknop-server
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko2 (= ${binary:Version}),
 iptables, lsb-base (>= 3.0-6)
Suggests: fwknop-apparmor-profile
Description: FireWall KNock OPerator server side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, thus preventing any connections from being processed on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.

Package: fwknop-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko2 (= ${binary:Version})
Description: FireWall KNock OPerator client side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the client program responsible for accepting password input
 from the user, constructing SPA packets that conform to the fwknop
 packet format, and encrypting packet data.

Package: libfko-python
Section: python
Architecture: linux-any
Depends: ${python:Depends}, ${misc:Depends}, libfko2 (= ${binary:Version}),
 ${shlibs:Depends}
Description: FireWall KNock OPerator - Python module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the FKO module as a Python interface.

Package: fwknop-apparmor-profile
Architecture: all
Depends: fwknop-server, ${misc:Depends}
Description: FireWall KNock OPerator - Apparmor profile
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the apparmor profile for the FireWall KNock OPerator server.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DEB_HOST_MULTIARCH        := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CFLAGS                    := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS                  := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS                   := $(shell dpkg-buildflags --get LDFLAGS)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
    confflags += --build $(DEB_HOST_GNU_TYPE)
else
    confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

TMP_LIBFKOPERL     = $(CURDIR)/debian/libfko-perl
TMP_LIBFKOPYTHON   = $(CURDIR)/debian/libfko-python

LIB_LIBFKODEV      = usr/lib/$(DEB_HOST_MULTIARCH)

PERL_ARCHLIB       = $(shell perl -MConfig -e 'print $$Config{vendorarch}')

%:
	dh $@ --with=python2

override_dh_auto_clean:
	dh_auto_clean
#	rm -rf m4

override_dh_auto_configure:
#	mkdir m4
	chmod +x ./debian/autogen.sh
	./debian/autogen.sh
	dh_auto_configure -- $(confflags) --with-gpgme --with-gpg=/usr/bin/gpg

override_dh_auto_build:
	dh_auto_build
	cd perl/FKO && perl Makefile.PL INSTALLDIRS=vendor
	make -C perl/FKO OPTIMIZE="$(CFLAGS) $(CPPFLAGS)" OTHERLDFLAGS="$(LDFLAGS)"
	make -C doc html
	cd python && python setup.py build

override_dh_auto_install:
	dh_auto_install
	cd perl/FKO && $(MAKE) install DESTDIR=$(TMP_LIBFKOPERL) PREFIX=/usr
	chrpath -d $(TMP_LIBFKOPERL)$(PERL_ARCHLIB)/auto/FKO/FKO.so
	cd python && python setup.py install --root=$(TMP_LIBFKOPYTHON) --install-layout=deb

override_dh_installinit:
	dh_apparmor -pfwknop-apparmor-profile --profile-name=usr.sbin.fwknopd
	dh_installinit

override_dh_link:
	dh_link -plibfko2-dev $(LIB_LIBFKODEV)/libfko.so.2.0.0 $(LIB_LIBFKODEV)/libfko.so
	dh_link --remaining-packages

override_dh_fixperms-arch:
	dh_fixperms
	chmod 600 $(CURDIR)/debian/fwknop-server/etc/fwknop/access.conf
	chmod 600 $(CURDIR)/debian/fwknop-server/etc/fwknop/fwknopd.conf

override_dh_strip:
	dh_strip --dbg-package=libfko2-dbg

## fwknop 2.6.5-maemo1

=== test/fko-wrapper/Makefile ===

all : fko_wrapper.c fko_basic.c
	cc -Wall -g -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko
	cc -Wall -g -I../../lib fko_basic.c -o fko_basic -L../../lib/.libs -lfko

fuzzing: fko_wrapper.c
	cc -Wall -g -DFUZZING_INTERFACES -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko

faultinjection: fko_fault_injection.c
	cc -Wall -g -DFIU_ENABLE -I../../lib fko_fault_injection.c -o fko_fault_injection -L../../lib/.libs -lfiu -lfko

clean:
	rm -f fko_wrapper fko_basic fko_fault_injection

=== debian/changelog ===
fwknop (2.6.5-maemo1) unstable; urgency=low

  * Added libpcap0.8-dev to build-depends. Not really needed, but the
    autoconf/configure/make process seems to still want to build some
    libpcap related object files.

 -- Alexander Kozhevnikov <mentalisttraceur@gmail.com>  Tue, 17 Feb 2015 03:12:13 -0500

fwknop (2.6.5-maemo0) unstable; urgency=low

  * Initial release to Maemo 5 repos.

 -- Alexander Kozhevnikov <mentalisttraceur@gmail.com>  Thu, 12 Feb 2015 02:48:09 +0000

=== debian/control ===
Source: fwknop
Section: user/network
Priority: extra
Maintainer: Alexander Kozhevnikov <mentalisttraceur@gmail.com>
Build-Depends: debhelper (>= 5), automake, libtool, iptables, dpkg-dev, libpcap0.8-dev
Standards-Version: 3.7.2
Homepage: http://www.cipherdyne.com/fwknop/

Package: libfko2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FireWall KNock OPerator - shared library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter (this version
 is NOT built to use libpcap).
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the runtime library for fwknop (written in C).

Package: fwknop-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko2 (= ${binary:Version}), iptables
Description: FireWall KNock OPerator server side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter (this version
 is NOT built to use libpcap).
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.

Package: fwknop-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko2 (= ${binary:Version})
Description: FireWall KNock OPerator client side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter (this version
 is NOT built to use libpcap).
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the client program responsible for accepting password input
 from the user, constructing SPA packets that conform to the fwknop
 packet format, and encrypting packet data.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1




CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/ --enable-udp-server

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#docbook-to-man debian/aircrack-ng.sgml > aircrack-ng.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/fwknop
	$(MAKE) DESTDIR=$(CURDIR)/debian/fwknop install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installchangelogs ChangeLog
#	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	maemo-optify
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## fwknop 2.6.5-maemo2

=== debian/changelog ===
fwknop (2.6.5-maemo2) unstable; urgency=low

  * Added debian/*.{dirs/install} files, hopefully will package properly
    now.
  * Applied upsteam patch to fix building without libpcap-dev
  * Concordantly removed libpcap-dev build-dependency.

 -- Alexander Kozhevnikov <mentalisttraceur@gmail.com>  Wed, 18 Feb 2015 01:11:21 -0500

## fwknop 2.6.5-maemo3

=== debian/changelog ===
fwknop (2.6.5-maemo3) unstable; urgency=low

  * Fixed ./configure --localstatedir argument

 -- Alexander Kozhevnikov <mentalisttraceur@gmail.com>  Wed, 18 Feb 2015 01:42:12 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: user/network
 Priority: extra
 Maintainer: Alexander Kozhevnikov <mentalisttraceur@gmail.com>
-Build-Depends: debhelper (>= 5), automake, libtool, iptables, dpkg-dev, libpcap0.8-dev
+Build-Depends: debhelper (>= 5), automake, libtool, iptables, dpkg-dev
 Standards-Version: 3.7.2
 Homepage: http://www.cipherdyne.com/fwknop/

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 configure-stamp:
 	dh_testdir
 	# Add here commands to configure the package.
-	./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/ --enable-udp-server
+	./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var --enable-udp-server
 
 	touch configure-stamp

## fwknop 2.6.9

=== extras/openwrt/package/fwknop/Makefile ===
include $(TOPDIR)/rules.mk

PKG_NAME:=fwknopd
PKG_VERSION:=2.0
PKG_RELEASE:=1

PKG_BUILD_DIR:=$(BUILD_DIR)/fwknop-$(PKG_VERSION)
PKG_SOURCE:=fwknop-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://www.cipherdyne.org/fwknop/download
PKG_MD5SUM:=c78252216fa9627cacf61b453da915a8
PKG_CAT:=zcat
include $(INCLUDE_DIR)/package.mk

define Package/fwknopd
       SECTION:=net
       CATEGORY:=Network
       DEFAULT:=n
       TITLE:=Firewall Knock Operator Daemon
       URL:=http://http://www.cipherdyne.org/fwknop/
       MAINTAINER:=Jonathan Bennett <jbscience87@gmail.com>
       DEPENDS:=+libpcap +iptables
endef

define Package/fwknopd/description
       Firewall Knock Operator Daemon
       Fwknop implements an authorization scheme known as Single Packet
       Authorization (SPA) for Linux systems running iptables.  This mechanism
       requires only a single encrypted and non-replayed packet to communicate
       various pieces of information including desired access through an iptables
       policy. The main application of this program is to use iptables in a
       default-drop stance to protect services such as SSH with an additional
       layer of security in order to make the exploitation of vulnerabilities
       (both 0-day and unpatched code) much more difficult.
endef

define Package/Conffiles
       fwknopd.conf
endef

CONFIGURE_ARGS += \
       --disable-client \
       --without-gpgme \
       --with-iptables=/usr/sbin/iptables



define Package/fwknopd/install
       $(INSTALL_DIR) $(1)/usr/sbin
       $(INSTALL_DIR) $(1)/etc/fwknop
       $(INSTALL_DIR) $(1)/etc/init.d
       $(INSTALL_DIR) $(1)/usr/lib
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/extras/fwknop.init.openwrt $(1)/etc/init.d/fwknopd
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/server/.libs/fwknopd $(1)/usr/sbin/
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/lib/.libs/libfko.so.0.0.2 $(1)/usr/lib/libfko.so.0
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/lib/.libs/libfko.so.0.0.2 $(1)/usr/lib/libfko.so.0.0.2
       $(INSTALL_CONF) $(PKG_BUILD_DIR)/server/fwknopd.conf $(1)/etc/fwknop/
       $(INSTALL_CONF) $(PKG_BUILD_DIR)/server/access.conf $(1)/etc/fwknop/

endef

$(eval $(call BuildPackage,fwknopd))
#
# Copyright (C) 2006-2009 OpenWrt.org
#
# This is free software, licensed under the GNU General Public License v2.
# See /LICENSE for more information.
#

include $(TOPDIR)/rules.mk

PKG_NAME:=fwknop
PKG_VERSION:=2.0.0rc1
PKG_RELEASE:=1

PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://www.dstuart.org/fwknop/
PKG_MD5SUM:=86c41edbe78bd15e6e5e351741cb26dd

include $(INCLUDE_DIR)/package.mk

PKG_INSTALL=1

define Package/fwknop
  SECTION:=net
  CATEGORY:=Network
  DEPENDS:=+gpgme +libgdbm +libpcap +iptables
  TITLE:=Firewall KNock OPerator - fwknop
  URL:=http://www.cipherdyne.org/fwknop
endef

define Package/fwknop/description
	Fwknop implements an authorization scheme known as Single Packet
	Authorization (SPA) for Linux systems running iptables.  This mechanism
	requires only a single encrypted and non-replayed packet to communicate
	various pieces of information including desired access through an iptables
	policy. The main application of this program is to use iptables in a
	default-drop stance to protect services such as SSH with an additional
	layer of security in order to make the exploitation of vulnerabilities
	(both 0-day and unpatched code) much more difficult.
endef

TARGET_CFLAGS += $(FPIC)

define Build/Configure
	$(call Build/Configure/Default, \
		--enable-shared \
		--enable-static \
		--with-gpgme \
		--with-gpg=/usr/bin/gpg \
		--with-iptables=/usr/sbin/iptables \
		--with-sh=/bin/sh \
	)
endef

define Build/InstallDev
	$(INSTALL_DIR) $(1)/usr/include
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/include/fko.h \
		$(1)/usr/include/

	$(INSTALL_DIR) $(1)/usr/lib
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/lib/libfko.{la,a,so*} \
		$(1)/usr/lib/
endef

define Package/fwknop/install
	$(INSTALL_DIR) $(1)/usr/lib
	$(INSTALL_DATA) $(PKG_INSTALL_DIR)/usr/lib/libfko.so.* $(1)/usr/lib/
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/fwknop $(1)/usr/bin/
	$(INSTALL_DIR) $(1)/usr/sbin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/fwknopd $(1)/usr/sbin/
	$(INSTALL_DIR) $(1)/etc/fwknop
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/fwknop/fwknopd.conf $(1)/etc/fwknop/
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/fwknop/access.conf $(1)/etc/fwknop/
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/fwknopd.init $(1)/etc/init.d/fwknopd
endef

$(eval $(call BuildPackage,fwknop))

=== debian/changelog ===
fwknop (2.6.9-2) unstable; urgency=medium

  * QA upload.
  * Drop upstart system job.
  * s/libcap/libpcap/ in long descriptions. Closes: #836890.
  * debhelper compat 10.
  * Don't activate triggers twice.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 05 Oct 2017 20:36:06 +0200

fwknop (2.6.9-1) unstable; urgency=medium

  * QA upload.
  * New upstream release 
    - Closes: #826718 - Please update fwknop
    - Patches:
      + Updated spelling.diff patch
      + Added new patch 002_fkoversion.diff
    - Added debian/source/include-binaries files
    - libfko2* packages become libfko3* packages to follow shared library
      number change.
    - Updated debian/copyright accordingly and fixed some lintian warnings.
  * Bump up debian policy from 3.9.5 to 3.9.8: no changes
  * Removed debug package which is automatically built.
  * Removed ldconfig call from libfko maintainer scripts and added
    libfko3.triggers to replace them. 
  * Fixed debian/control: 
    - Use secure URI (https) for VCS field
    - Added dh-python to BD field
  * Added GPG signature verification to debian/watch file. Upstream GPG
    signature is stored in debian/upstream/signing-key.asc.

 -- Franck Joncourt <franck.joncourt@gmail.com>  Sat, 27 Aug 2016 22:09:29 +0200

=== debian/control ===
Source: fwknop
Section: admin
Priority: extra
Build-Depends: debhelper (>= 10), automake, libtool, libgpgme11-dev,
 texinfo, libpcap0.8-dev, po-debconf, libgdbm-dev, iptables,
 dpkg-dev (>= 1.16.1~), chrpath, python-all-dev, dh-apparmor,
 dh-python
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.1.1
Vcs-Git: https://anonscm.debian.org/collab-maint/fwknop.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/fwknop.git;a=summary
Homepage: http://www.cipherdyne.com/fwknop/
X-Python-Version: >= 2.7

Package: libfko3-dev
Architecture: linux-any
Section: libdevel
Breaks: libfko2-dev
Replaces: libfko2-dev
Suggests: libfko-doc
Depends: ${shlibs:Depends}, libfko3 (= ${binary:Version}), ${misc:Depends}
Description: FireWall KNock OPerator - development library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the development library and its headers.

Package: libfko3
Section: libs
Architecture: linux-any
Breaks: libfko2
Replaces: libfko2
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FireWall KNock OPerator - shared library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the runtime library for fwknop (written inC).

Package: libfko-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: FireWall KNock OPerator - documentation
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the library documentation.

Package: libfko-perl
Section: perl
Architecture: linux-any
Depends: ${perl:Depends},  libfko3 (= ${binary:Version}), ${shlibs:Depends},
 ${misc:Depends}
Description: FireWall KNock OPerator - Perl module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected. 
 .
 This package provides the FKO module as a Perl interface.

Package: fwknop-server
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko3 (= ${binary:Version}),
 iptables, lsb-base (>= 3.0-6)
Suggests: fwknop-apparmor-profile
Description: FireWall KNock OPerator server side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, thus preventing any connections from being processed on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.

Package: fwknop-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfko3 (= ${binary:Version})
Description: FireWall KNock OPerator client side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the client program responsible for accepting password input
 from the user, constructing SPA packets that conform to the fwknop
 packet format, and encrypting packet data.

Package: libfko-python
Section: python
Architecture: linux-any
Depends: ${python:Depends}, ${misc:Depends}, libfko3 (= ${binary:Version}),
 ${shlibs:Depends}
Description: FireWall KNock OPerator - Python module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the FKO module as a Python interface.

Package: fwknop-apparmor-profile
Architecture: all
Depends: fwknop-server, ${misc:Depends}
Description: FireWall KNock OPerator - Apparmor profile
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the apparmor profile for the FireWall KNock OPerator server.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEB_HOST_MULTIARCH        := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CFLAGS                    := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS                  := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS                   := $(shell dpkg-buildflags --get LDFLAGS)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
    confflags += --build $(DEB_HOST_GNU_TYPE)
else
    confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

TMP_LIBFKOPERL     = $(CURDIR)/debian/libfko-perl
TMP_LIBFKOPYTHON   = $(CURDIR)/debian/libfko-python

LIB_LIBFKODEV      = usr/lib/$(DEB_HOST_MULTIARCH)

PERL_ARCHLIB       = $(shell perl -MConfig -e 'print $$Config{vendorarch}')

%:
	dh $@ --with=python2

override_dh_auto_clean:
	dh_auto_clean
#	rm -rf m4

override_dh_auto_configure:
#	mkdir m4
	chmod +x ./debian/autogen.sh
	./debian/autogen.sh
	dh_auto_configure -- $(confflags) --with-gpgme --with-gpg=/usr/bin/gpg

override_dh_auto_build:
	dh_auto_build
	cd perl/FKO && perl Makefile.PL INSTALLDIRS=vendor
	make -C perl/FKO OPTIMIZE="$(CFLAGS) $(CPPFLAGS)" OTHERLDFLAGS="$(LDFLAGS)"
	make -C doc html
	cd python && python setup.py build

override_dh_auto_install:
	dh_auto_install
	cd perl/FKO && $(MAKE) install DESTDIR=$(TMP_LIBFKOPERL) PREFIX=/usr
	chrpath -d $(TMP_LIBFKOPERL)$(PERL_ARCHLIB)/auto/FKO/FKO.so
	cd python && python setup.py install --root=$(TMP_LIBFKOPYTHON) --install-layout=deb

override_dh_installinit:
	dh_apparmor -pfwknop-apparmor-profile --profile-name=usr.sbin.fwknopd
	dh_installinit

override_dh_link:
	dh_link -plibfko3-dev $(LIB_LIBFKODEV)/libfko.so.3.0.0 $(LIB_LIBFKODEV)/libfko.so
	dh_link --remaining-packages

override_dh_fixperms-arch:
	dh_fixperms
	chmod 600 $(CURDIR)/debian/fwknop-server/etc/fwknop/access.conf
	chmod 600 $(CURDIR)/debian/fwknop-server/etc/fwknop/fwknopd.conf

override_dh_strip:
	dh_strip -plibfko3 --dbgsym-migration='libfko2-dbg'
	dh_strip --remaining-packages

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ http://www.cipherdyne.com/fwknop/download/fwknop-([\.0-9].*).tar.gz

## fwknop 2.6.10

=== test/fko-wrapper/Makefile ===
--- 
+++ 
@@ -2,6 +2,14 @@
 all : fko_wrapper.c fko_basic.c
 	cc -Wall -g -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko
 	cc -Wall -g -I../../lib fko_basic.c -o fko_basic -L../../lib/.libs -lfko
+
+asan : fko_wrapper.c fko_basic.c
+	cc -Wall -fsanitize=address -fno-omit-frame-pointer -g -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko
+	cc -Wall -fsanitize=address -fno-omit-frame-pointer -g -I../../lib fko_basic.c -o fko_basic -L../../lib/.libs -lfko
+
+ubsan : fko_wrapper.c fko_basic.c
+	cc -Wall -fsanitize=undefined -g -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko
+	cc -Wall -fsanitize=undefined -fno-omit-frame-pointer -g -I../../lib fko_basic.c -o fko_basic -L../../lib/.libs -lfko
 
 fuzzing: fko_wrapper.c
 	cc -Wall -g -DFUZZING_INTERFACES -I../../lib fko_wrapper.c -o fko_wrapper -L../../lib/.libs -lfko

=== debian/changelog ===
fwknop (2.6.10-8) unstable; urgency=medium

  * Mark libfko3-dev as "Multi-Arch: same".

 -- Francois Marier <francois@debian.org>  Sat, 22 Feb 2020 09:30:09 -0800

fwknop (2.6.10-7) unstable; urgency=medium

  * Revert NFQ capture support since it disables pcap capture.

 -- Francois Marier <francois@debian.org>  Tue, 18 Feb 2020 08:08:43 -0800

fwknop (2.6.10-6) unstable; urgency=medium

  * Add missing "Wants" directive in systemd service file (closes: #949323)
  * Enable support for NFQ capture (closes: #949331)
  * Bump Standards-Version up to 4.5.0.
  * Replace debian/compat with debhelper-compat (= 12).

 -- Francois Marier <francois@debian.org>  Sat, 15 Feb 2020 11:38:27 -0800

fwknop (2.6.10-5) unstable; urgency=medium

  * Stop building libfko-python since it's Python2-only (closes: #936575).

 -- Francois Marier <francois@debian.org>  Thu, 12 Sep 2019 10:32:19 -0700

fwknop (2.6.10-4) unstable; urgency=medium

  * Patch /run directory handling.
  * Fix typo in Restart directive of systemd service file.
  * Bump Standards-Version to 4.4.0.

 -- Francois Marier <francois@debian.org>  Mon, 08 Jul 2019 13:20:10 -0700

fwknop (2.6.10-3) unstable; urgency=medium

  * Restart fwknop-server on failure (closes: #927392)
  * Make libfko3 and libfko-perl "Multi-Arch: same" (Multiarch hinter)

 -- Francois Marier <francois@debian.org>  Sat, 06 Jul 2019 14:34:40 -0700

fwknop (2.6.10-2) unstable; urgency=medium

  * Remove all debconf leftovers (closes: #581635)

 -- Francois Marier <francois@debian.org>  Thu, 28 Feb 2019 10:37:06 -0800

fwknop (2.6.10-1) unstable; urgency=medium

  * New upstream release (closes: #923086)
    - new `--server-resolve-ipv4` option
    - drop all patches (merged upstream)
  * Patch AppArmor profile (closes: #911485).
  * Adopt this package (closes: #831273).
  * Add myself to debian/copyright.
  * Move repo to salsa.debian.org.

  * Add a build-depend on wget (closes: #840565).
  * Mention START_DAEMON (closes: #844016).
  * Move state files to /run/fwknop (closes: #911483).
  * Cleanup old files in /var/fwknop and remove 1.9.x cleanups.
  * Update postrm file to cleanup /run/fwknop
  * Add a logcheck rule for fwknop-server.
  * Include upstream systemd unit files.

  * Bump Standards-Version to 4.3.0.
  * Bump debhelper compat to 12.
  * Use HTTPS URL in debian/copyright.
  * Add missing people and years to debian/copyright.
  * Use HTTPS URL for upstream homepage.
  * USe HTTPS URL in debian/watch.
  * Update source link to GitHub.
  * Run wrap_and_sort -ast.
  * Remove unnecessary X-Python{,3}-Version field in debian/control.
  * Trim trailing whitespace.
  * Change priority extra to priority optional.
  * Use /usr/share/dpkg/architecture.mk in debian/rules.
  * Remove obsolete dbgsym-migration line in debian/rules.
  * Mark the -doc package as "Multi-Arch: foreign".

 -- Francois Marier <francois@debian.org>  Mon, 25 Feb 2019 14:56:20 -0800

=== debian/control ===
Source: fwknop
Section: admin
Priority: optional
Build-Depends:
 automake,
 chrpath,
 debhelper-compat (= 12),
 dh-apparmor,
 dpkg-dev (>= 1.16.1~),
 iptables,
 libgdbm-dev,
 libgpgme11-dev,
 libpcap0.8-dev,
 libtool,
 texinfo,
 wget,
Maintainer: Francois Marier <francois@debian.org>
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian/fwknop.git
Vcs-Browser: https://salsa.debian.org/debian/fwknop
Homepage: https://www.cipherdyne.com/fwknop/

Package: libfko3-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Breaks:
 libfko2-dev,
Replaces:
 libfko2-dev,
Suggests:
 libfko-doc,
Depends:
 libfko3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - development library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the development library and its headers.

Package: libfko3
Section: libs
Architecture: linux-any
Multi-Arch: same
Breaks:
 libfko2,
Replaces:
 libfko2,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - shared library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the runtime library for fwknop (written inC).

Package: libfko-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: FireWall KNock OPerator - documentation
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the library documentation.

Package: libfko-perl
Section: perl
Architecture: linux-any
Multi-Arch: same
Depends:
 libfko3 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - Perl module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the FKO module as a Perl interface.

Package: fwknop-server
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 iptables,
 libfko3 (= ${binary:Version}),
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fwknop-apparmor-profile,
Description: FireWall KNock OPerator server side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, thus preventing any connections from being processed on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.

Package: fwknop-client
Architecture: linux-any
Depends:
 libfko3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator client side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the client program responsible for accepting password input
 from the user, constructing SPA packets that conform to the fwknop
 packet format, and encrypting packet data.

Package: fwknop-apparmor-profile
Architecture: all
Depends:
 fwknop-server,
 ${misc:Depends},
Description: FireWall KNock OPerator - Apparmor profile
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the apparmor profile for the FireWall KNock OPerator server.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://www.cipherdyne.com/fwknop/download/fwknop-([\.0-9].*).tar.gz
